import winappdbg
from winappdbg import Color
from winappdbg import EventHandler
from winappdbg.win32 import *
import sys
import time
import urlparse
import base64

debug_target = 'jusched.exe'
debug_cnc = '172.16.48.130'

def print_script(str):
	Color.white()
	Color.light()
	print '[%s] %s' % (time.strftime("%Y-%m-%d %H:%M:%S",time.gmtime()), str)
	Color.reset()
	return
	
def print_modification(str):
	Color.red()
	Color.light()
	print '[%s] %s' % (time.strftime("%Y-%m-%d %H:%M:%S",time.gmtime()), str)
	Color.reset()
	return

def print_hook(str):
	Color.yellow()
	Color.light()
	print '[%s] %s' % (time.strftime("%Y-%m-%d %H:%M:%S",time.gmtime()), str)
	Color.reset()

def print_network(str):
	Color.green()
	Color.light()
	print '[%s] %s' % (time.strftime("%Y-%m-%d %H:%M:%S",time.gmtime()), str)
	Color.reset()

def print_process(str):
	Color.cyan()
	Color.light()
	print '[%s] %s' % (time.strftime("%Y-%m-%d %H:%M:%S",time.gmtime()), str)
	Color.reset()
	
def print_internal(str):
	Color.magenta()
	Color.light()
	print '[%s] %s' % (time.strftime("%Y-%m-%d %H:%M:%S",time.gmtime()), str)
	Color.reset()
	
def get_state(event):
	process = event.get_process()
	thread = event.get_thread()
	context = thread.get_context()
	return process, thread, context
	
def patch_cnc(event):
	"""
	Breakpoint: 0x00401B38
	Patch the CnC to ours
	"""
	process, thread, context = get_state(event)
	original_cnc = process.peek_string(0x004339BC)
	process.write(0x004339BC,debug_cnc+'\x00')
	print_modification('Modified CnC from %s to %s' % (original_cnc, debug_cnc))
	
	esp = context['Esp']
	process.write_dword(esp+0x04, len(debug_cnc));
	print_modification('  Patched length to %i' % (len(debug_cnc)))
	
	return
	
def patch_install_check(event):
	"""
	Breakpoint: 0x00408FE8
	Fix the install check so that we can run this from anywhere, and not require a run
	key in the registry
	"""
	process, thread, context = get_state(event)
	eax = context['Eax']
	if eax == 0:
		print_modification('Not installed, patching check to proceed')
		thread.set_register('Eax',1)
	else:
		print_modification('Installed, no need to patch')
	return
	
def shell_execute_blocker(event):
	"""
	Breakpoint: 0x0040B796
	Blocks JackPOS' attempt to run its watchdog process (AppData\Local\Temp\svchost.exe).
	All it appears to do is re-execute JackPOS if it dies, and we honestly don't need it for
	our purposes.
	"""
	process, thread, context = get_state(event)
	esp = context['Esp']
	p_file = process.peek_dword(esp+0x08)
	file = process.peek_string(p_file,fUnicode=True)
	print_modification('Blocking execution of: %s' % file)
	thread.set_register('Esp',esp+0x18)
	thread.set_register('Eip',0x40B79C)
	return
	
def open_url(event):
	"""
	Breakpoint: 0x00402F84
	"""
	process, thread, context = get_state(event)
	esp = context['Esp']
	p_url = process.peek_dword(esp+0x04)
	url = process.peek_string(p_url,fUnicode=True)
	print_network('Opening %s' % url)
	return

def cnc_online(event):
	"""
	Breakpoint: 0x0040320A
	"""
	process, thread, context = get_state(event)
	esp = context['Esp']
	p_url = process.peek_dword(esp+0x04)
	url = process.peek_string(p_url,fUnicode=True)
	print_network('Testing to see if CnC is up via %s' % url)
	return

def cnc_online_end(event):
	"""
	Breakpoint: 0x00403321
	Looking at the results of testing online status of the CnC
	"""
	process, thread, context = get_state(event)
	eax = context['Eax']
	if eax:
		print_network('  CnC server is up.')
	else:
		print_network('  CnC server is down')
	return

def cnc_send(event):
	"""
	Breakpoint: 0x004035BC
	This is where we're sending data to the CnC. MAC address and track data, if any
	"""
	process, thread, context = get_state(event)
	esp = context['Esp']
	p_optional = process.peek_dword(esp+0x0c)
	optional = process.peek_string(p_optional)
	posted_data = urlparse.parse_qs(optional)
	print_network('Checked into CnC with MAC address %s' % posted_data['mac'][0]) 
	if posted_data.has_key('t1'):
		padding_needed = len(posted_data['t1'][0]) % 4
		for i in range(0,padding_needed):
			posted_data['t1'][0] += '='
		print_network('Sent Track 1 data:\n%s' % base64.b64decode(posted_data['t1'][0]))
	if posted_data.has_key('t2'):
		padding_needed = len(posted_data['t2'][0]) % 4
		for i in range(0,padding_needed):
			posted_data['t2'][0] += '='
		print_network('Sent Track 2 data:\n%s' % base64.b64decode(posted_data['t2'][0]))
	return	
	
def cnc_recv(event):
	"""
	Breakpoint: 0x00403627
	Right after we read the data the CnC sends back to us after checking in
	"""
	process, thread, context = get_state(event)
	eax = context['Eax']
	data = process.peek_string(eax)
	if data != '':
		print_network('CnC sent: %s' % data)
	return
	
def search_process(event):
	"""
	Breakpoint: 0x00409388
	"""
	process, thread, context = get_state(event)
	ecx = context['Ecx']
	print_process('Searching PID %s' % ecx)
	return

def process_kill(event):
	"""
	Breakpoint: 0x004099FE
	Command has been tested and matches "kill"
	"""
	process, thread, context = get_state(event)
	eax = context['Eax']
	if eax == 0:
		print_internal('Processing command: kill')
	return
	
def kill__block_registry_cleanup(event):
	"""
	Breakpoint: 0x00408DAC
	Skip registry cleanup
	"""
	process, thread, context = get_state(event)
	ebp = context['Ebp']
	p_subkey = process.peek_dword(ebp+0x08)
	p_value_name = process.peek_dword(ebp+0x20) 
	subkey = process.peek_string(p_subkey, fUnicode=True)
	value_name = process.peek_string(p_value_name, fUnicode=True)
	print_modification('Blocking deletion of %s\%s' % (subkey, value_name))
	thread.set_register('Esp',ebp+0x08)
	thread.set_register('Eip',0x00408DB2)
	return

def process_update(event):
	"""
	Breakpoint: 0x004095E6
	By virtue of getting here, we're processing the "update" command
	"""
	process, thread, context = get_state(event)
	print_internal('Processing command: update')
	return
	
def process_exec(event):
	"""
	Breakpoint: 0x00409CA7
	Command has been tested and matches "exec"
	"""
	process, thread, context = get_state(event)
	eax = context['Eax']
	if eax != 0:
		print_internal('Processing command: exec')
	return
	
breakpoints = [(0x00401B38, patch_cnc),
			   (0x00408FE8, patch_install_check),
			   (0x0040B796, shell_execute_blocker),
			   (0x00402F84, open_url),
			   (0x0040320A, cnc_online),
			   (0x00403321, cnc_online_end),
			   (0x004035BC, cnc_send),
			   (0x00403627, cnc_recv),
			   (0x00409388, search_process),
			   (0x004099FE, process_kill),
			   (0x00408DAC, kill__block_registry_cleanup),
			   (0x004095E6, process_update),
			   (0x00409CA7, process_exec),
			   ]


#######

dbg = winappdbg.Debug(bKillOnExit=True)

try:
	dbg.execl(debug_target)
	pid = dbg.get_debugee_pids()[0]
	print_script('Launched target: (%i) %s' % (pid, debug_target))
	print_script('Setting breakpoints')
	for bp in breakpoints:
		print_script('  %s -> %s' % (hex(bp[0]),bp[1].__name__))
		dbg.break_at(pid, bp[0], bp[1])
	dbg.loop()
finally:
	dbg.stop()

print_script('Target exited')