<?php

class SiteController extends Controller
{
	public function actionIndex()
	{
		if(!Yii::app()->user->getIsGuest())
			$this->redirect("/panel/");
		$model=new LoginForm;
		if(isset($_POST['LoginForm']))
		{
			$model->attributes=$_POST['LoginForm'];
			// validate user input and redirect to the previous page if valid
			if($model->validate() && $model->login())
				$this->redirect(Yii::app()->user->returnUrl);
			else
				$this->removeCaptchaSession();
		}
		$this->render('index',array('model'=>$model));
	}
	public function actionLogout()
	{
		Yii::app()->user->logout();
		$this->redirect(Yii::app()->homeUrl);
	}
	protected function removeCaptchaSession()
	{
		$session = Yii::app()->session;
		$prefixLen = strlen(CCaptchaAction::SESSION_VAR_PREFIX);
		foreach ($session->keys as $key)
		{
			if (strncmp(CCaptchaAction::SESSION_VAR_PREFIX, $key, $prefixLen) == 0)
			$session->remove($key);
		}
	}
    public function actions(){
        return array(
            'captcha'=>array(
                'class'=>'CCaptchaAction',
                'width'=>300,
                'foreColor'=>0x34495e,
                'minLength'=>6,
                'maxLength'=>10,
                //'fontFile'=>'CaptchaCode.ttf'
            ),
        );
    }
}