<?php

/**
 * LoginForm class.
 * LoginForm is the data structure for keeping
 * user login form data. It is used by the 'login' action of 'SiteController'.
 */
class ChangePasswordForm extends CFormModel
{
	public $password0;
	public $password1;
	public $password2;
	public $user;

	public function rules()
	{
		return array(
			array('password0, password1, password2', 'required'),
        	array('password1', 'match', 'pattern'=>'/^(?=.*\d+)[0-9a-zA-Z!@#$%]{8,}$/i','message'=>'The password must be at least 8 characters long and contain at least one digit.'),
        	array('password1', 'compare', 'compareAttribute'=>'password2'),
			// password0 needs to be authenticated
			array('password0', 'check_password'),
		);
	}
	public function attributeLabels()
	{
		return array(
			'password0'=>'Old password',
			'password1'=>'New Password',
			'password2'=>'Repeated password'
		);
	}
	
	public function check_password($attribute,$params)
	{
		if(!$this->hasErrors())
		{
			if($this->user->hashPassword($this->password0)!=$this->user->password)
				$this->addError('password0','The old password is not valid.');
		}
	}
	
	public function change_password()
	{
		$this->user->password = $this->user->hashPassword($this->password1);
		$this->user->save();
	}
}
