<?php
class Country extends CActiveRecord
{
	public function tableName()
	{
		return 'countries';
	}
 
	public function rules()
	{
		return array(
			array('id, code, name', 'required'),
			// The following rule is used by search().
			array('id, code, name', 'safe', 'on'=>'search'),
		);
	}
 
	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		return array(
			'range' => array(self::HAS_MANY, 'Range', 'country_id')
		);
	}

	public function attributeLabels()
	{
		return array(
			'id' => Yii::t('models','ID'),
			'code' => Yii::t('models','Country code'),
			'name' => Yii::t('models','Country')
		);
	}

	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}