<!DOCTYPE html>
<html lang="en">
	<head>
		<title><?php echo CHtml::encode($this->pageTitle); ?></title>
		<meta name="viewport" content="width=device-width, initial-scale=1.0">
		<!-- Bootstrap -->
		<link href="<?php echo Yii::app()->request->baseUrl; ?>/assets/css/bootstrap.min.css" rel="stylesheet" media="screen">
		<link href="<?php echo Yii::app()->request->baseUrl; ?>/assets/css/bootstrap-select.css" rel="stylesheet" media="screen">
		<link href="<?php echo Yii::app()->request->baseUrl; ?>/assets/css/bootstrap-datetimepicker.min.css" rel="stylesheet" media="screen">
		<link href="<?php echo Yii::app()->request->baseUrl; ?>/assets/css/site.css" rel="stylesheet" media="screen">

		<!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
		<!--[if lt IE 9]>
		  <script src="../../assets/js/html5shiv.js"></script>
		  <script src="../../assets/js/respond.min.js"></script>
		<![endif]-->
		<!-- Include all compiled plugins (below), or include individual files as needed -->
		<script src="<?php echo Yii::app()->request->baseUrl; ?>/assets/js/bootstrap.min.js"></script>
		<script src="<?php echo Yii::app()->request->baseUrl; ?>/assets/js/bootstrap-select.js"></script>
		<script src="<?php echo Yii::app()->request->baseUrl; ?>/assets/js/bootstrap-datetimepicker.min.js"></script>
		<script src="<?php echo Yii::app()->request->baseUrl; ?>/assets/js/bootstrap-bootbox.min.js"></script>
	</head>
	<body>
		<div class="container">
			<div class="row logo">
				<div class="col-md-6">
					<h1 class="logo"><?php echo Yii::app()->name; ?></h1>
				</div>
				<div class="col-md-6" align="right">
					<h2 class="lato">Welcome, <?php echo Yii::app()->user->name; ?></h2>
					<h4 class="lato"><a href="/site/logout/">Logout</a></h4>
				</div>
			</div>
			<div class="row">
				<div class="col-md-3">
		<div class="todo">
			<ul>
<?php
$pages = array(
	"index"=>array(
		"name"=>"Home page",
		"desc"=>"View all general information you need."
	),
	"dumps"=>array(
		"name"=>"Dumps",
		"desc"=>"Check all dumps."
	),
	"bots"=>array(
		"name"=>"Bots",
		"desc"=>"Manage all bots."
	),
	"settings"=>array(
		"name"=>"Settings",
		"desc"=>"Change account's settings."
	)
);
foreach($pages as $link=>$data):
?>
<li class="todo-<?php echo $link==$this->action->id?"done":""; ?>" onclick="window.location='/panel/<?php echo $link;?>';">
	<div class="todo-icon glyphicon glyphicon-<?php echo $link==$this->action->id?"ok":"chevron-right"; ?>"></div>
	<div class="todo-content">
		<h4 class="todo-name">
			<strong><?php print $data["name"];?></strong>
		</h4>
		<?php print $data["desc"];?>
	</div>
</li>
<?php
endforeach;
?>
			</ul>
		</div>
				</div>
				<div class="col-md-9">
					<div class="jumbotron content">
						<?php echo $content; ?>
					</div>
				</div>
			</div>
			<div align="center">Server Time: <span id="clock_time"></span></div>
			<script>
				var datetime = new Date('<?php echo date("Y-m-d H:i:s"); ?>');
				function show_time(){
					$("#clock_time").html(datetime.toLocaleString());
				}
				show_time();
				setInterval(function(){
					show_time();
					datetime.setSeconds(datetime.getSeconds() + 1);
				},1000);
			</script>
		</div>
	</body>
</html>
